using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Configuration;
using System.Diagnostics;
using System.Text;

namespace AWC.Reporter.Web
{
	/// <summary>
	/// Summary description for Writeback.
	/// </summary>
	public partial class Writeback : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DropDownList drpReports;
	
		protected void Page_Load(object sender, System.EventArgs e)
		{
			if (!this.IsPostBack)
			{
                string salesOrderNumber = Request["SO"];
                string lineNumber = Request["LN"];
				if (String.IsNullOrEmpty(salesOrderNumber)) 
				{
					lblResults.Text = "Sales order number is missing.";
					return;
				}
                if (String.IsNullOrEmpty(lineNumber) == null)
                {
                    lblResults.Text = "Line number is missing.";
                    return;
                }
				// load the order details
                LoadLineItem(salesOrderNumber, lineNumber);
			}

		}

		/// <summary>
		/// Get the line item details.
		/// </summary>
		/// <param name="salesOrderNumber">The Order Number passed as a query string</param>
		private void LoadLineItem(string salesOrderNumber, string lineNumber)
		{
			SqlConnection connection = new SqlConnection();
			SqlDataReader reader = null;
			try 
			{
                string sql = "SELECT OrderQty, UnitPrice, UnitPriceDiscount FROM Sales.SalesOrderDetail WHERE SalesOrderID = @SalesOrderID AND SalesOrderDetailID = @SalesOrderDetailID";
				connection.ConnectionString = ConfigurationSettings.AppSettings["connectionString"];
				SqlCommand sqlCmd = new SqlCommand(sql, connection);
                sqlCmd.Parameters.Add("@SalesOrderID", SqlDbType.Int).Value = salesOrderNumber;
                sqlCmd.Parameters.Add("@SalesOrderDetailID", SqlDbType.Int).Value = lineNumber;
				sqlCmd.Connection.Open();
				reader = sqlCmd.ExecuteReader(CommandBehavior.CloseConnection);

				// we expect exactly one record
				reader.Read();
				lblSalesOrderNumber.Text = salesOrderNumber;
                lblLineNumber.Text = lineNumber;
                txtOrderQty.Text = reader[0].ToString();
                txtUnitPrice.Text = reader[1].ToString();
                txtUnitPriceDiscount.Text = reader[2].ToString();
				
			}
			catch (System.Exception ex)
			{
				reader.Close();
				connection.Close();
				throw ex;
			}			
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    

		}
		#endregion

		protected void lnkUpdate_Click(object sender, System.EventArgs e)
		{
			StringBuilder sb = new StringBuilder();
			sb.Append ("Line Item Updated<br>");
			sb.Append (String.Format("Sales Order Number: {0}<br>", lblSalesOrderNumber.Text));
            sb.Append(String.Format("Sales Order Number: {0}<br>", lblLineNumber.Text));
			sb.Append (String.Format("Order Quantity: {0}<br>", txtOrderQty.Text));
            sb.Append(String.Format("Unit Price: {0}<br>", txtUnitPrice.Text));
            sb.Append(String.Format("Unit Price Discount: {0}<br>", txtUnitPriceDiscount.Text));
			lblResults.Text = sb.ToString();
		}
	}
}
